#include <iostream>
#include <algorithm>
using namespace std;

const int Dim = 302, Inf = 1e9; // 1 miliard

int a[Dim][Dim];
int n, m;

int main()
{
	// citirea datelor de intrare
	cin >> n;
	
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
		{			
			cin >> a[i][j];             
			a[i][j] += a[i - 1][j];
		}
		
	// Acum, a[i][j] reprezinta suma partiala pe coloana j, pana la linia i
			
	
	int s_max = -Inf;
	// generam toate submatricile 
	// Complexitate: O(n^3)
	for (int i1 = 1; i1 <= n; ++i1)
		for (int i2 = i1; i2 <= n; ++i2)
		{
			int s = 0;
			for (int j = 1; j <= n; ++j)
			{
				s += a[i2][j] - a[i1 - 1][j];
				
				if (s > s_max)
					s_max = s;
				if (s < 0)
					s = 0;
			}
		}
				
	cout << s_max;
}

